<?php
/** start x-File Manager **/
function xFileManager()
{
	global $context, $db_prefix, $scripturl, $modSettings, $user_info, $txt, $boarddir;

	$context['xfm']['upload_path']	= $boarddir . '/attachments/xfm_uploads/';
	$context['xfm']['ftp_path']	= $boarddir . '/attachments/xfm_uploads_ftp/';

	if(!file_exists($context['xfm']['upload_path']))
		mkdir($context['xfm']['upload_path']);

	if(!file_exists($context['xfm']['ftp_path']))
		mkdir($context['xfm']['ftp_path']);

	// if admin, move folders from ftp folder
	if($context['user']['is_admin'])
	{
		if($handle = opendir($context['xfm']['ftp_path']))
		{
			while(false !== ($_file = readdir($handle)))
			{
				if($_file != '.' && $_file != '..')
				{
					if(isset($_POST['ftp_save_to']) && isset($_POST['ftp_move']))
					{
						$file['f_path'] = $context['xfm']['ftp_path'].$_file;
						$file['array'] 	= explode('.', trim($_file));
						$file['ext']	= strtolower(array_pop($file['array']));
						$file['type'] 	= xfm_get_mime($file['ext']);
						$file['size']	= filesize($file['f_path']);
						$file['f_name']	= xfm_random_name(20);
						$file['level']	= count(explode('/', $_POST['ftp_save_to']))-1;

						copy($file['f_path'], $context['xfm']['upload_path'].$file['f_name']);
						@unlink($file['f_path']);
						db_query("
							INSERT INTO `{$db_prefix}xfm_files`
								(`ID`, `F_NAME`, `LEVEL`, `PATH`, `NAME`, `TYPE`, `EXT`, `SIZE`, `OWNER`, `PERMS`, `DATE`)
								VALUES
								(NULL, '{$file['f_name']}', '{$file['level']}', '{$_POST['ftp_save_to']}', '".implode('.', $file['array'])."', '{$file['type']}', '{$file['ext']}', '{$file['size']}', '{$context['member']['id']}', '0', UNIX_TIMESTAMP())", __FILE__, __LINE__);
					}
					$context['xfm']['new_files']++;
				}
			}
			closedir($handle);
			if(isset($_POST['ftp_save_to']) && isset($_POST['ftp_move']))
				redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path']);
		}
	}

	$context['xfm']['path'] 	= (!empty($_GET['path'])) ? $_GET['path'] : '/';

	// Processing "level up" directory
	$context['xfm']['lvl_up'] 	= explode('/', trim($context['xfm']['path'], '/'));
	array_pop($context['xfm']['lvl_up']);
	$context['xfm']['lvl_up'] 	= implode('/', $context['xfm']['lvl_up']);
	$context['xfm']['lvl_up'] 	= ($context['xfm']['lvl_up'] != '') ? '/'.$context['xfm']['lvl_up'].'/' : '/';
	$context['xfm']['level'] 	= count(explode('/', $context['xfm']['path']))-1;
  if(empty($modSettings['xfm_num_of_posts'])) $modSettings['xfm_num_of_posts'] = 0;
  if(empty($modSettings['xfm_allow_list'])) $modSettings['xfm_allow_list'] = false;
	$context['xfm']['allow_listning'] = ((!$context['user']['is_owner'] && $context['user']['is_logged'] && $modSettings['xfm_allow_list']) || $context['user']['is_admin'] || ($modSettings['xfm_num_of_posts'] != 0 && ($context['user']['is_owner'] && $user_info['posts'] >= $modSettings['xfm_num_of_posts'])) || ($context['user']['is_owner'] && $modSettings['xfm_num_of_posts'] == 0)) ? true : false;

	if($context['user']['is_admin'] || ($context['user']['is_owner'] && (!empty($modSettings['xfm_num_of_posts']) || $modSettings['xfm_num_of_posts'] != 0 && $user_info['posts'] >= $modSettings['xfm_num_of_posts'])) || ($context['user']['is_owner'] && empty($modSettings['xfm_num_of_posts']) || $modSettings['xfm_num_of_posts'] == 0))
	{
		if(isset($_POST['upload_files']))
		{
			checkSession('post');
			for($i = 0; $i < count($_FILES['file']['name']); $i++)
			{
				if(!empty($_FILES['file']['name'][$i]) && file_exists($_FILES['file']['tmp_name'][$i]))
				{
					$file['array'] 	= explode('.', trim($_FILES['file']['name'][$i]));
					$file['type'] 	= $_FILES['file']['type'][$i];
					$file['size']	= $_FILES['file']['size'][$i];
					$file['save_to']= $_POST['save_to'][$i];
					$file['ext']	= strtolower(array_pop($file['array']));
					$file['name'] 	= (trim($_POST['name'][$i]) != '') ? str_replace(array('"', '\'', '/', '\\'), '_', $_POST['name'][$i]) : implode('.', $file['array']);
					$file['f_name']	= xfm_random_name(20);
					$file['level']	= count(explode('/', $file['save_to']))-1;

					move_uploaded_file($_FILES['file']['tmp_name'][$i], $context['xfm']['upload_path'].$file['f_name']);

					db_query("
						INSERT INTO `{$db_prefix}xfm_files`
							(`ID`, `F_NAME`, `LEVEL`, `PATH`, `NAME`, `TYPE`, `EXT`, `SIZE`, `OWNER`, `PERMS`, `DATE`)
							VALUES
							(NULL, '{$file['f_name']}', '{$file['level']}', '{$file['save_to']}', '{$file['name']}', '{$file['type']}', '{$file['ext']}', '{$file['size']}', '{$context['member']['id']}', '0', UNIX_TIMESTAMP())", __FILE__, __LINE__);
				}
			}

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path']);
		}
		elseif(isset($_POST['create_dir']))
		{
			checkSession('post');
      //$dirName = trim($_POST['dir_name']);
		    $dirName = trim(preg_replace('/\W+/', '_', $_POST['dir_name']), '_');
			$result = db_query("
				SELECT * FROM `{$db_prefix}xfm_files`
					WHERE `TYPE` = 'FOLDER'
					AND `PATH` = '{$context['xfm']['path']}'
					AND `LEVEL` = '{$context['xfm']['level']}'
					AND `NAME` = '".str_replace(array('"', '\'', '/', '\\'), '_', $dirName)."/'
					AND `OWNER` = '{$context['member']['id']}'", __FILE__, __LINE__);
			if(mysql_num_rows($result) > 0)
			{
				redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';msg=f_exists');
				exit($txt['xfm']['folder_exists']);
			}
			mysql_free_result($result);
		    if(empty($dirName))
		    {
        		fatal_lang_error('empty_dir_name');
		    }
	        db_query("
				INSERT INTO `{$db_prefix}xfm_files`
					(`ID`, `F_NAME`, `LEVEL`, `PATH`, `NAME`, `TYPE`, `EXT`, `SIZE`, `OWNER`, `PERMS`, `DATE`)
					VALUES
					(NULL, 'folder', '{$context['xfm']['level']}', '{$context['xfm']['path']}', '".str_replace(array('"', '\'', '/', '\\'), '_', $dirName)."/', 'FOLDER', '0', '0', '{$context['member']['id']}', '0', UNIX_TIMESTAMP())", __FILE__, __LINE__);
			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path']);
		}
		elseif(isset($_GET['folder']) && $_GET['f_act'] == 'delete')
		{
			checkSession('get');
			db_query("
				DELETE FROM `{$db_prefix}xfm_files`
					WHERE `NAME` = '{$_GET['folder']}'
					AND `PATH` = '{$context['xfm']['path']}'
					AND `OWNER` = '{$context['member']['id']}'
						LIMIT 1", __FILE__, __LINE__);

			db_query("
				DELETE FROM `{$db_prefix}xfm_files`
					WHERE `PATH` LIKE '".$context['xfm']['path'].$_GET['folder']."%'
					AND `TYPE` = 'FOLDER'
					AND `OWNER` = '{$context['member']['id']}'
						LIMIT 1", __FILE__, __LINE__);

			$result = db_query("
				SELECT * FROM `{$db_prefix}xfm_files`
					WHERE `PATH` LIKE '".$context['xfm']['path'].$_GET['folder']."%'
					AND `OWNER` = '{$context['member']['id']}'", __FILE__, __LINE__);

			while($row = mysql_fetch_assoc($result))
				if(db_query("
					DELETE FROM `{$db_prefix}xfm_files`
						WHERE `F_NAME` = '{$row['F_NAME']}'
						AND `OWNER` = '{$context['member']['id']}'
							LIMIT 1", __FILE__, __LINE__))
					unlink($context['xfm']['upload_path'].$row['F_NAME']);

				redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(isset($_GET['file']) && $_GET['f_act'] == 'delete' )
		{
			checkSession('get');
			if(db_query("
				DELETE FROM `{$db_prefix}xfm_files`
					WHERE `F_NAME` = '{$_GET['file']}'
					AND `OWNER` = '{$context['member']['id']}'
						LIMIT 1", __FILE__, __LINE__))
				unlink($context['xfm']['upload_path'].$_GET['file']);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(isset($_GET['file']) && $_GET['f_act'] == 'rename' && $_GET['new_name'] != '')
		{
			checkSession('post');
			$m_fileName = trim(preg_replace('/\W+/', '_', $_GET['new_name']), '_');
		    if(empty($m_fileName))
		    {
        		fatal_lang_error('empty_file_name');
		    }
			db_query("
				UPDATE `{$db_prefix}xfm_files`
					SET `NAME` = '{$_GET['new_name']}'
						WHERE `F_NAME` = '{$_GET['file']}'
						AND `OWNER` = '{$context['member']['id']}'
							LIMIT 1", __FILE__, __LINE__);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(isset($_GET['folder']) && $_GET['f_act'] == 'rename' && $_GET['new_name'] != '')
		{
			checkSession('post');
			$lvl = count(explode('/', trim($_GET['path'].$_GET['folder'], '/ ')));
			$new_name = trim(preg_replace('/\W+/', '_', $_GET['new_name']), '_');

    	    if(empty($new_name))
            {
        		fatal_lang_error('empty_dir_name');
		    }
	        $new_name .='/';
			$result = db_query("
				SELECT * FROM `{$db_prefix}xfm_files`
					WHERE `TYPE` = 'FOLDER'
					AND `LEVEL` = '$lvl'
					AND `NAME` = '$new_name'
					AND `OWNER` = '{$context['member']['id']}'", __FILE__, __LINE__);
			if(mysql_num_rows($result) > 0)
			{
				redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';msg=f_exists');
				exit($txt['xfm']['folder_exists']);
			}
			mysql_free_result($result);

			db_query("
				UPDATE `{$db_prefix}xfm_files`
					SET `NAME` = '{$new_name}'
						WHERE `NAME` = '{$_GET['folder']}'
						AND `OWNER` = '{$context['member']['id']}'
						AND `LEVEL` = '{$lvl}'
							LIMIT 1", __FILE__, __LINE__);

			$result = db_query("
				SELECT `ID`, `PATH` FROM `{$db_prefix}xfm_files`
					WHERE `OWNER` = '{$context['member']['id']}'
					AND `PATH` LIKE '".$_GET['path'].$_GET['folder']."%'
						ORDER BY `EXT`", __FILE__, __LINE__);

			while($row = mysql_fetch_assoc($result))
			{
				db_query("
					UPDATE `{$db_prefix}xfm_files`
						SET `PATH` = '".str_replace($_GET['path'].$_GET['folder'], $_GET['path'].$new_name, $row['PATH'])."'
							WHERE `ID` = '{$row['ID']}'", __FILE__, __LINE__);
			}

			mysql_free_result($result);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(isset($_POST['c_delete']))
		{
			checkSession('get');
			for($i = 0; $i < count($_POST['check']); $i++)
				if(db_query("
					DELETE FROM `{$db_prefix}xfm_files`
						WHERE `F_NAME` = '".$_POST['check'][$i]."'
						AND `OWNER` = '{$context['member']['id']}'
							LIMIT 1", __FILE__, __LINE__))
					unlink($context['xfm']['upload_path'].$_POST['check'][$i]);

				redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(isset($_POST['c_move']))
		{
			checkSession('post');
			$lvl = count(explode('/', $_POST['dist_folder']))-1;

			for($i = 0; $i < count($_POST['check']); $i++)
				db_query("
					UPDATE `{$db_prefix}xfm_files`
						SET `PATH` = '{$_POST['dist_folder']}', `LEVEL` = '$lvl'
							WHERE `F_NAME` = '".$_POST['check'][$i]."'
							AND `OWNER` = '{$context['member']['id']}'
								LIMIT 1", __FILE__, __LINE__);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(($context['user']['is_admin'] || $context['user']['is_owner']) && isset($_GET['folder']) && $_GET['f_act'] == 'lock')
		{
			checkSession('get');
			$lvl = count(explode('/', trim($_GET['path'].$_GET['folder'], '/ ')));

			db_query("
				UPDATE `{$db_prefix}xfm_files`
					SET `PERMS` = '1'
						WHERE `NAME` = '{$_GET['folder']}'
						AND `OWNER` = '{$context['member']['id']}'
						AND `PATH` = '{$_GET['path']}'
						AND `LEVEL` = '$lvl'
							LIMIT 1", __FILE__, __LINE__);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
		elseif(($context['user']['is_admin'] || $context['user']['is_owner']) && isset($_GET['folder']) && $_GET['f_act'] == 'unlock')
		{
			checkSession('get');
			$lvl = count(explode('/', trim($_GET['path'].$_GET['folder'], '/ ')));

			db_query("
				UPDATE `{$db_prefix}xfm_files`
					SET `PERMS` = '0'
						WHERE `NAME` = '{$_GET['folder']}'
						AND `OWNER` = '{$context['member']['id']}'
						AND `PATH` = '{$_GET['path']}'
						AND `LEVEL` = '$lvl'
							LIMIT 1", __FILE__, __LINE__);

			redirectexit($scripturl.'?action=profile;u='.$context['member']['id'].';sa=xFileManager;path='.$context['xfm']['path'].';p='.(isset($_GET['p'])?$_GET['p']:'1'));
		}
	}

  if(empty($modSettings['xfm_allow_guest_to_download'])) $modSettings['xfm_allow_guest_to_download'] = false;
	if($context['user']['is_guest'] && $modSettings['xfm_allow_guest_to_download'] || $context['user']['is_logged'])
	{
		if(isset($_GET['file']) && $_GET['f_act'] == 'download')
		{
			$result = db_query("
				SELECT * FROM `{$db_prefix}xfm_files`
					WHERE `F_NAME` = '{$_GET['file']}'
						LIMIT 1", __FILE__, __LINE__);

			if(mysql_num_rows($result) > 0)
			{
				while($row = mysql_fetch_assoc($result))
				{
					db_query("
						UPDATE `{$db_prefix}xfm_files`
							SET `DOWNLOADS` = `DOWNLOADS` + 1
								WHERE `F_NAME` = '{$_GET['file']}'
									LIMIT 1", __FILE__, __LINE__);
					header('Pragma: public');
					header('Expires: 0');
					header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
					header('Cache-Control: public');
					header('Content-Description: File Transfer');
					header('Content-Type: '.$row['TYPE']);
					// send file
					header('Content-Disposition: filename="'.$row['NAME'].'.'.$row['EXT'].'";');
					header('Content-Transfer-Encoding: binary');
					header('Content-Length: '.filesize($context['xfm']['upload_path'].$_GET['file']));
					readfile($context['xfm']['upload_path'].$_GET['file']);
					exit();
				}
			}
			else
			{
				exit();
			}
		}
	}
	else
	{
		fatal_error($txt['xfm']['listing_error'], false);
	}

	$modSettings['xfm_num_on_page'] = (empty($modSettings['xfm_num_on_page'])) ? 10 : $modSettings['xfm_num_on_page'];

	$context['xfm']['page_now'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1) ? 1 : $_GET['p'];

	$result = db_query("
		SELECT `ID` FROM `{$db_prefix}xfm_files`
			WHERE `LEVEL` = '{$context['xfm']['level']}'
			AND `OWNER` = '{$context['member']['id']}'
			AND `PATH` LIKE '{$context['xfm']['path']}%'", __FILE__, __LINE__);
	$context['xfm']['items_in_folder'] = mysql_num_rows($result);
	mysql_free_result($result);

	$context['xfm']['total_pages'] = ceil($context['xfm']['items_in_folder']/$modSettings['xfm_num_on_page']);

	$newpath = explode('/', trim($context['xfm']['path'], '/'));
	$result = db_query("
		SELECT `PERMS` FROM `{$db_prefix}xfm_files`
			WHERE `LEVEL` = '".($context['xfm']['level']-1)."'
			AND `OWNER` = '{$context['member']['id']}'
			AND `NAME` = '".array_pop($newpath)."/'
			AND `PATH` LIKE '/".implode('/', $newpath)."%'", __FILE__, __LINE__);
	$context['xfm']['is_locked_folder'] = (mysql_num_rows($result) > 0) ? mysql_result($result, 0) : 0;
	mysql_free_result($result);

	if($context['xfm']['is_locked_folder'] == 0 || $context['user']['is_admin'] || $context['user']['is_owner'])
	{
		$result = db_query("
			SELECT * FROM `{$db_prefix}xfm_files`
				WHERE `LEVEL` = '{$context['xfm']['level']}'
				AND `OWNER` = '{$context['member']['id']}'
				AND `PATH` LIKE '{$context['xfm']['path']}%'
					ORDER BY `EXT`
						LIMIT ".($context['xfm']['page_now']-1)*$modSettings['xfm_num_on_page'].", {$modSettings['xfm_num_on_page']}", __FILE__, __LINE__);

		while($row = mysql_fetch_assoc($result))
		{
			if($row['TYPE'] == 'FOLDER')
			{
				$folders= 0;
				$files	= 0;
				$result_c = db_query("
					SELECT `TYPE` FROM `{$db_prefix}xfm_files`
						WHERE `OWNER` = '{$context['member']['id']}'
						AND `PATH` = '".$context['xfm']['path'].$row['NAME']."'
							ORDER BY `NAME`", __FILE__, __LINE__);
				while($items_in = mysql_fetch_assoc($result_c))
					if($items_in['TYPE'] == 'FOLDER')
						$folders++;
					else
						$files++;
				mysql_free_result($result_c);

				$context['xfm']['folders'][$row['ID']] 	= array(
					'name'		=> trim($row['NAME'], '/'),
					'files_in'	=> $files,
					'folders_in'	=> $folders,
					'date'		=> $row['DATE'],
					'perms'		=> $row['PERMS']
				);
			}
			else
				$context['xfm']['files'][$row['ID']] 	= array(
					'fname' 	=> $row['F_NAME'],
					'name' 		=> $row['NAME'],
					'type' 		=> $row['TYPE'],
					'ext' 		=> $row['EXT'],
					'size' 		=> $row['SIZE'],
					'downloads' 	=> $row['DOWNLOADS'],
					'date' 		=> $row['DATE']
				);
		}

		mysql_free_result($result);
	}
	$result = db_query("
		SELECT `PATH`, `NAME` FROM `{$db_prefix}xfm_files`
			WHERE `TYPE` = 'FOLDER'
			AND `OWNER` = '{$context['member']['id']}'
				ORDER BY `NAME`", __FILE__, __LINE__);

	$context['xfm']['folders_list'] = '<option value="/">/</option>';
	while($folder = mysql_fetch_assoc($result))
		$context['xfm']['folders_list'] .= '<option value="'.$folder['PATH'].$folder['NAME'].'">'.$folder['PATH'].rtrim($folder['NAME'], '/').'</option>';

	mysql_free_result($result);
	$context['page_title'] = $txt['xfm']['file_manager_title'];
}

function xfm_random_name($length=11, $type='a-zA-Z0-9')
{
	$return = null;
	if(strstr($type, 'a-z'))
		$chars = 'abcdefghijklmnopqrstuvwxyz';
	if(strstr($type, 'A-Z'))
		$chars .= 'ABCDEFGHIJKLMNOPRQSTUVWXYZ';
	if(strstr($type, '0-9'))
		$chars .= '0123456789';

	$sl = strlen($chars) - 1;

	for($i = 0; $i < $length; $i++)
		$return .= $chars[mt_rand(0,$sl)];

	return $return;
}

function xfm_calc_size($size)
{
	if( $size < 1024)
		return round($size, 1).' Bytes';
	if( $size > 1024*1024)
		return round(($size/(1024*1024)), 1).' MB';

	return round(($size/1024), 1).' KB';
}

function xfm_get_mime($ext)
{
	$mimeTypes = array(
		"ez" => "application/andrew-inset",
		"hqx" => "application/mac-binhex40",
		"cpt" => "application/mac-compactpro",
		"doc" => "application/msword",
		"bin" => "application/octet-stream",
		"dms" => "application/octet-stream",
		"lha" => "application/octet-stream",
		"lzh" => "application/octet-stream",
		"exe" => "application/octet-stream",
		"class" => "application/octet-stream",
		"so" => "application/octet-stream",
		"dll" => "application/octet-stream",
		"oda" => "application/oda",
		"pdf" => "application/pdf",
		"ai" => "application/postscript",
		"eps" => "application/postscript",
		"ps" => "application/postscript",
		"smi" => "application/smil",
		"smil" => "application/smil",
		"wbxml" => "application/vnd.wap.wbxml",
		"wmlc" => "application/vnd.wap.wmlc",
		"wmlsc" => "application/vnd.wap.wmlscriptc",
		"bcpio" => "application/x-bcpio",
		"vcd" => "application/x-cdlink",
		"pgn" => "application/x-chess-pgn",
		"cpio" => "application/x-cpio",
		"csh" => "application/x-csh",
		"dcr" => "application/x-director",
		"dir" => "application/x-director",
		"dxr" => "application/x-director",
		"dvi" => "application/x-dvi",
		"spl" => "application/x-futuresplash",
		"gtar" => "application/x-gtar",
		"hdf" => "application/x-hdf",
		"js" => "application/x-javascript",
		"skp" => "application/x-koan",
		"skd" => "application/x-koan",
		"skt" => "application/x-koan",
		"skm" => "application/x-koan",
		"latex" => "application/x-latex",
		"nc" => "application/x-netcdf",
		"cdf" => "application/x-netcdf",
		"sh" => "application/x-sh",
		"shar" => "application/x-shar",
		"swf" => "application/x-shockwave-flash",
		"sit" => "application/x-stuffit",
		"sv4cpio" => "application/x-sv4cpio",
		"sv4crc" => "application/x-sv4crc",
		"tar" => "application/x-tar",
		"tcl" => "application/x-tcl",
		"tex" => "application/x-tex",
		"texinfo" => "application/x-texinfo",
		"texi" => "application/x-texinfo",
		"t" => "application/x-troff",
		"tr" => "application/x-troff",
		"roff" => "application/x-troff",
		"man" => "application/x-troff-man",
		"me" => "application/x-troff-me",
		"ms" => "application/x-troff-ms",
		"ustar" => "application/x-ustar",
		"src" => "application/x-wais-source",
		"xhtml" => "application/xhtml+xml",
		"xht" => "application/xhtml+xml",
		"zip" => "application/zip",
		"au" => "audio/basic",
		"snd" => "audio/basic",
		"mid" => "audio/midi",
		"midi" => "audio/midi",
		"kar" => "audio/midi",
		"mpga" => "audio/mpeg",
		"mp2" => "audio/mpeg",
		"mp3" => "audio/mpeg",
		"aif" => "audio/x-aiff",
		"aiff" => "audio/x-aiff",
		"aifc" => "audio/x-aiff",
		"m3u" => "audio/x-mpegurl",
		"ram" => "audio/x-pn-realaudio",
		"rm" => "audio/x-pn-realaudio",
		"rpm" => "audio/x-pn-realaudio-plugin",
		"ra" => "audio/x-realaudio",
		"wav" => "audio/x-wav",
		"pdb" => "chemical/x-pdb",
		"xyz" => "chemical/x-xyz",
		"bmp" => "image/bmp",
		"gif" => "image/gif",
		"ief" => "image/ief",
		"jpeg" => "image/jpeg",
		"jpg" => "image/jpeg",
		"jpe" => "image/jpeg",
		"png" => "image/png",
		"tiff" => "image/tiff",
		"tif" => "image/tif",
		"djvu" => "image/vnd.djvu",
		"djv" => "image/vnd.djvu",
		"wbmp" => "image/vnd.wap.wbmp",
		"ras" => "image/x-cmu-raster",
		"pnm" => "image/x-portable-anymap",
		"pbm" => "image/x-portable-bitmap",
		"pgm" => "image/x-portable-graymap",
		"ppm" => "image/x-portable-pixmap",
		"rgb" => "image/x-rgb",
		"xbm" => "image/x-xbitmap",
		"xpm" => "image/x-xpixmap",
		"xwd" => "image/x-windowdump",
		"igs" => "model/iges",
		"iges" => "model/iges",
		"msh" => "model/mesh",
		"mesh" => "model/mesh",
		"silo" => "model/mesh",
		"wrl" => "model/vrml",
		"vrml" => "model/vrml",
		"css" => "text/css",
		"html" => "text/html",
		"htm" => "text/html",
		"asc" => "text/plain",
		"txt" => "text/plain",
		"rtx" => "text/richtext",
		"rtf" => "text/rtf",
		"sgml" => "text/sgml",
		"sgm" => "text/sgml",
		"tsv" => "text/tab-seperated-values",
		"wml" => "text/vnd.wap.wml",
		"wmls" => "text/vnd.wap.wmlscript",
		"etx" => "text/x-setext",
		"xml" => "text/xml",
		"xsl" => "text/xml",
		"mpeg" => "video/mpeg",
		"mpg" => "video/mpeg",
		"mpe" => "video/mpeg",
		"qt" => "video/quicktime",
		"mov" => "video/quicktime",
		"mxu" => "video/vnd.mpegurl",
		"avi" => "video/x-msvideo",
		"movie" => "video/x-sgi-movie",
		"ice" => "x-conference-xcooltalk");
	return (isset($mimeTypes[$ext])) ? $mimeTypes[$ext] : 'application/octet-stream' ;
}
/** end x-File Manager **/

?>